1209.带分数

题目连接

思路

由1 - 9组成带分数,因为每个数只能出现一次,所以就枚举出1 - 9的全排列,然后把它分为三个部分,用双重循环考虑所有情况,最后算出结果即可。

代码

cpp 复制代码
#include <bits/stdc++.h>
using namespace std;
const int N = 100;
int ans[N]; //记录全排列结果 
bool f[N]; 
int n, res = 0;
void dfs(int u)
{
	//如果到了第十个数,就可以开始计算,并返回 
	if (u > 9)
	{
//		for (int i = 1; i <= 9; i ++ )
//		{
//			cout << ans[i] << " ";
//		}
//		cout << endl;
		
		//枚举整数部分的位数 
		for (int i = 1; i <= 7; i ++ )
		{
			//枚举分子部分的位数 
			for (int j = 1; j <= 8 - i; j ++ )
			{
				//算出分子的位数 
				int k = 9 - i - j;
				
				//记录每一部分的数值 
				int a = 0, b = 0, c = 0;
				
				//算出整数部分 
				for (int f = 1; f <= i; f ++ )
				{
					a = a * 10 + ans[f];
				}
				
				//算出分子部分 
				for (int f = i + 1; f <= i + j; f ++ )
				{
					b = b * 10 + ans[f];
				}
				
				//算出分母部分 
				for (int f = i + j + 1; f <= 9; f ++ )
				{
					c = c * 10 + ans[f];
				}
//				cout << a << " " << b << " " << c << endl;
				if (b % c == 0 && a + b / c == n)
				{
					res ++;
				}
			}
		}
	}
	
	//枚举9个数 
	for (int i = 1; i <= 9; i ++ )
	{
		//如果当前数没被选过 
		if (!f[i])
		{
			f[i] = 1; //标记为选过 
			ans[u] = i; //记录该数 
			dfs(u + 1); //进入下一个位置 
			f[i] = 0; //标记为未选过  
		}
	}
}
int main()
{
	cin >> n;
	dfs(1);
	cout << res;
	return 0;
}

总结

不是很难

相关推荐
hanlin0310 小时前
刷题笔记:力扣第32题-最长有效括号
笔记·算法·leetcode
All for pursuit.10 小时前
【动态规划-21】312.戳气球
数据结构·c++·算法·leetcode·动态规划
碧海银沙音频科技研究院12 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI13 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo62313 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y13 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu13 小时前
笛卡尔树
算法·图论
026d2313 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生14 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生14 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构